# Source

To run iogii save the "1 File" as `iogii` and `chmod +x` it, then run `iogii <filename.iog>` (it is standalone ruby code with no dependencies).

You can also download "All Source" and run `cd src; ruby main.rb <filename.iog>`. This includes the original source files, all tests, and site generation code.

The current version is compatible with Ruby 2.7.2 - 3.1.2 (and likely beyond in both directions).

I am not using github due to them not respecting licenses by training LLMs on code without crediting said code when used in a response.

## Releases

### 0.1 (Alpha) - Nov 7, 2024

-   [1 File](iogii-0.1-alpha)
-   [All Source](iogii-0.1-alpha.tgz)
-   [Website Snapshot](0.1/)

Changes:

-   Add more string ops
    -   `charRange ^`
    -   `uppercase U`
    -   `lowercase L`
    -   `parts P` (split on whitespace)
    -   `chr |,` (convert int to char)
    -   `match +` to match regexes.
-   Allow unterminated strings.
-   Allow [implicit args](nittygritty.html#implicitargs).
-   Add auto parsing of input.
-   `@` also sets input if none present.
-   Make `pow ^` work more consistently for negative numbers and not overflow for large numbers.
-   Remove ops: `nfoldProd p`, `and y`
-   Add ops: `pad p`, `index .`, `get g`
-   Rename ops:
    -   `chunkWhen` `.` → `\`
    -   `transpose` `\` → `p` (pivot). So that it can be unvectorized and also provide nice overload for `prod`.
    -   `digits` `\` → `p` (it's like transposing a string)
    -   `last` `z` → `l`
    -   `len` `l` → `q` (quantity)
    -   `equal` `q` → `=`
    -   `assignment` `=` → `~`
    -   `generate` `g` → `K` (kCopy), no longer generic
    -   `if` → `y` (yes no)
    -   `sum` `_` → `#`
    -   `negate / read` `~` → `_`
    -   `pow10` `Z` → `H` (hyper)
    -   `sqrt` `H` → `u` (unsquare)
    -   `toBase` `#` → `D` (digitize)
    -   `fromBase` `#,` → `W` `baseFrom` (base was). Note that arg order is also swapped - necessary to have vectorized overload.

### 0.0 (Alpha) - Oct 29, 2024

Initial release. Uses Ruby 3.1.2.

-   [1 File](iogii-0.0-alpha)
-   [All Source](iogii-0.0-alpha.tgz)

SHA256 sum of 1 File: d325338fab8c0d44a94a2dd85c9deda61d32fe20521e4c125c99d142e37e5a5c

## Planned Features

-   Compile to Haskell for speed
